#include <math.h>
#include <stdlib.h> 
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h> 
#include <string>
#include <iostream>
#include <fstream>
#include "vect.h"
#include "settings.h"
#include "framebufferabstract.h"
#include "wereld.h"
#include <sys/stat.h>
using namespace std;

#define WERELDALPHA 0.5
const int triangles[12][3]={{1,0,2},{3,2,0},{0,1,4},{5,4,1},{1,2,5},{6,5,2},{2,3,6},{7,6,3},{0,4,3},{7,3,4},{5,4,6},{7,6,4}};

/*
0=x,z
1=x,z
2=x,y
3=x,y
4=z,y
5=z,y
6=x,y
7=x,y
8=y,z
9=y,z
10=x,z
11=x,z
*/


string onsets[20]={	"bzz",	"c",	"x",	"sch",	"g",	"gr",	"j",	"k",	"kr",	"b",	"b",	"z",	"pr",	"zj",	"v",	"w",	"n",	"m",	"ps",	"chr"};
string nuclei[15]={	"a",	"e",	"o",	"i",	"u",	"ui",	"au",	"ou",	"oe",	"eu",	"y",	"ie",	"ij",	"ei",	"eau"};
string codas[20]={	"rg",	"l",	"k",	"t",	"ng",	"rp",	"lk",	"rt",	"st",	"uw",	"m",	"n",	"z",	"mb",	"",	"",	"",	"",	"",	""};

string creeernaam(int aantalsylaben)
{
	if(aantalsylaben<1) aantalsylaben=1;
	string out="";
	for(int i=0;i<aantalsylaben;i++)
	{
		out+=onsets[rand()%20]+nuclei[rand()%15]+codas[rand()%20];
	}
//	out+=".png";
//	printf("Ik heb de naam %s voor de gevraagde screenshot bedacht.\n",out.c_str());
	return out;
}


void lopertje::vooruit()
{
	huidig+=mpw;
}

void lopertje::achtuit()
{
	huidig-=mpw;
}

void lopertje::update()
{
	huidig*=mwk;
	if(mmn>huidig) huidig=mmn;
	if(mmx<huidig) huidig=mmx;
	if(huidig<EPSILON && huidig>-EPSILON) huidig=0;
}

float lopertje::getWaarde()
{
	return huidig;
}

void lopertje::zetmij(float min,float max,float power,float wrijvingkracht)
{
	if(min>max)
	{
		float t=max;
		max=min;
		min=t;
	}
	
	if(power<0.0)power*=-1;
	if(power==0.0) power=0.1;
	
	if(wrijvingkracht<=0.0) wrijvingkracht=0.9;
	
	mmn=min;
	mmx=max;
	mpw=power;
	mwk=wrijvingkracht;
	huidig=0.0;
}

lopertje::lopertje(float min,float max,float power,float wrijvingkracht)
{
	zetmij(min,max,power,wrijvingkracht);
}

lopertje::lopertje()
{
	zetmij(0,1,1,0);
}

bij::bij(){zetmij(vect(0,0,0),NULL); }
bij::bij(vect pos,wereld *dewereld){	zetmij(pos,dewereld); }

void bij::zetmij(vect pos,wereld *dewereld)
{
	mijnwereld=dewereld;
	mijnpos.zetmij(pos);
	laatstestap.zetmij(vect(0,0,0));
	mijnspd.zetmij(0.0,1.0,0.05,0.9);
	mijnyaw.zetmij(-0.5,0.5,0.09,0.6);
	mijnpitch.zetmij(-0.3,0.3,0.1,0.5);
	yawrot=0;
	pitchval=0;
	iwarpedthisfar.zetmij(0.0);
	Ibumped=false;
	for(int i=0;i<STAPPEN;i++)
		vorigestappen[i].zetmij(mijnpos);
}

vect bij::getwarped()
{
	return iwarpedthisfar;
}

void bij::zetwereld(class wereld *dewereld)
{
	mijnwereld=dewereld;
}

void bij::viewpoint()
{

	glRotatef( 90.0+((yawrot*(180.0/M_PI))),0.0f,1.0f,0.0f);
	
	glTranslatef(-mijnpos.x,-mijnpos.y,-mijnpos.z);	
	
		
		
}
void bij::randomize()
{
	yawrot=randfloat(0.0,6.28);
	mijnspd.zetmij(0.0,BIJSPEED,0.5,0.9);
	mijnspd.vooruit();//hoef je tenminste niet te wachten tot de bij er zin in heeft
	mijnyaw.zetmij(-0.5*M_PI,0.5*M_PI,randfloat(0.775,0.815),0.7);
	mijnpitch.zetmij(-0.3,0.3,randfloat(0.05,0.15),0.5);
	
	mijnpos.x=randfloat(-20.0,20.0);
	mijnpos.y=1.0;//randfloat(0.2,0.9);
	mijnpos.z=randfloat(-20.0,20.0);
			
	
	if(mijnwereld!=NULL)
		for(int count=0;(!mijnwereld->vrijepositie(mijnpos)); count++)
		{
			printf("Heb al zo vaak geprobeerd een  specifieke bij te plaatsen: %d\n",count);
			mijnpos.x=randfloat(-20.0,20.0);
			mijnpos.y=1.0;//randfloat(0.2,0.9);
			mijnpos.z=randfloat(-20.0,20.0);
			
		
		}	
	for(int i=0;i<STAPPEN;i++)
		vorigestappen[i].zetmij(mijnpos);
}
	
void bij::draw()
{
		/*vect afstand(mijnpos);
		
		glBegin(GL_LINE_STRIP);
		glColor4f(1,0,0,WERELDALPHA);
		vertexvect(afstand);
		glColor4f(0,0,0,WERELDALPHA);
		
		for(int i=0;i<STAPPEN;i++)
		{
			if(i%2==0) 	glColor3f(1,1,0);
			else		glColor3f(0,0,0);
			
			vertexvect(*afstand.zetmij(vectminvect(afstand,vorigestappen[i])));
		}
		
		glEnd();
		
		vect mijnschaduw(mijnpos);
		mijnschaduw.y=0.001;
		afstand.zetmij(mijnschaduw);

		glBegin(GL_LINE_STRIP);
		glColor4f(0,0,0,WERELDALPHA*0.5);
		vertexvect(afstand);
				
		for(int i=0;i<STAPPEN;i++)
			vertexvect(*afstand.zetmij(vectminvect(afstand,vorigestappen[i])));
		
		
		glEnd();*/
		
}

void bij::draai()
{
	yawrot+=mijnyaw.getWaarde();
}

void bij::doestap()
{
	doestap(1.0);
}

float bij::lengtelaatstestap()
{
		return vectlengte(getlaatstestap());
}

void bij::doestap(float delta)
{
	laatstestap.zetmij(vect(0,0,0));
	
	delta_opgeteld+=delta;
	if(USEBIJSPEEDDIRECTLY)
	{
		laatstestap.z=sinf(yawrot)*BIJSPEED*delta;
		laatstestap.x=cosf(yawrot)*BIJSPEED*delta;
	}else{
		laatstestap.z=sinf(yawrot)*mijnspd.getWaarde()*delta;
		laatstestap.x=cosf(yawrot)*mijnspd.getWaarde()*delta;
	}
	
	if(mijnwereld!=NULL)
	{
		
		
		if(!mijnwereld->vrijepositie(vectplusvect(mijnpos,laatstestap)) || !mijnwereld->vrijepositie(vectplusvect(mijnpos,vectmult(laatstestap,2.0))))// || !mijnwereld->vrijepositie(vectplusvect(mijnpos,vectmult(laatstestap,3.0))))
		{
			/*const int swivel=rand()%5;
			if(rand()%2==0)	for(int i=0;i<swivel;i++) mijnyaw.vooruit();
			else		for(int i=0;i<swivel;i++) mijnyaw.achtuit();*/
			Ibumped=true;
			laatstestap.zetmij(0,0.0,0);
	
		}
			
	}
	
	mijnpos.zetmij(vectplusvect(mijnpos,laatstestap));
	
	
}

vect bij::getpos()
{
	return mijnpos;
}

vect bij::getlaatstestap()
{

	return vectminvect(mijnpos,vectplusvect(vorigestappen[1],iwarpedthisfar));
}


float bij::welkerichtingvliegiknuop()
{
	return yawrot;
}

bool bij::benikklaarmetmijnlaatstestap()
{
	if(delta_opgeteld<1.0)
		return false;
	
	
	for(int i=STAPPEN-1;i>0;i--)
		vorigestappen[i].zetmij(vorigestappen[i-1]);
	vorigestappen[0].zetmij(mijnpos);//vectminvect(mijnpos,vorigestappen[0]));
	
	double h;
	delta_opgeteld=modf(delta_opgeteld,&h);
	
	return true;
	
}

void bij::twistandturn()
{

	
	int lr=rand()%2;
	if(lr) 	yawrot+=M_PI/3.0;//mijnyaw.vooruit();
	else	yawrot-=M_PI/3.0;//mijnyaw.achtuit();
		
	
	
}

bool bij::didibump()
{

	return Ibumped;
}

void bij::update()
{
	
	
	if(Ibumped) twistandturn();
	Ibumped=false;
	if(rand()%3==0) 
		mijnspd.vooruit();
	int lr=rand()%25;
	if(lr==0) mijnyaw.vooruit();
	if(lr==1) mijnyaw.achtuit();
	
	mijnspd.update();
	mijnyaw.update();
	
	float rad=mijnwereld->getradius();
	vect oudmijnpos(mijnpos);
	if(mijnpos.x>rad) mijnpos.x-=rad*2;
	if(mijnpos.x<-rad) mijnpos.x+=rad*2;
	if(mijnpos.y>rad) mijnpos.y-=rad*2;
	if(mijnpos.y<-rad) mijnpos.y+=rad*2;
	if(mijnpos.z>rad) mijnpos.z-=rad*2;
	if(mijnpos.z<-rad) mijnpos.z+=rad*2;
	
	oudmijnpos.zetmij(vectminvect(mijnpos,oudmijnpos));
	
	if(vectlengte(oudmijnpos)>0.0) iwarpedthisfar.zetmij(oudmijnpos);
	else iwarpedthisfar.zetmij(0.0);

}
//	vect mijnpos;
//	lopertje mijnspd,mijnyaw,mijnpitch;

	


obstakel::obstakel(vect pos,float rot,vect dimensies)
{
	benikrond=false;
	center.zetmij(pos);
	berekenmij(pos,rot,dimensies);
	kleur.zetmij(randfloat(0,1),randfloat(0,1),randfloat(0,1));
}

obstakel::obstakel(vect pos,float rad,float hoogte)
{
	berekenmij(pos,rad,hoogte);
}

obstakel::obstakel()
{
	center.zetmij(0,0,0);
	for(int i=0;i<8;i++)
	{
		vertices[i][0]=0;
		vertices[i][1]=0;
		vertices[i][2]=0;
	}
	kleur.zetmij(0,0,0);
}

void obstakel::berekenmij(vect pos,float rad,float hoogte)
{
	if(rad<=0.0) rad=0.1;
	if(hoogte<=0.0) hoogte=1.0;
	mijnhoogte=hoogte;
	benikrond=true;
	center.zetmij(pos);
	grondcenter.zetmij(center);
	grondcenter.y=0.0;
	kleur.zetmij(randfloat(0,1),randfloat(0,1),randfloat(0,1));
	mijnrad=rad;
	
	overhoeveelrandenligikheen=0;
	klonen=NULL;
	
}

void obstakel::berekenmij(vect pos,float rot,vect dimensies)
{
	benikrond=false;
	center.zetmij(pos);
	mijndims.zetmij(dimensies);
	kleur.zetmij(randfloat(0,1),randfloat(0,1),randfloat(0,1));
	grondcenter.zetmij(pos);
	grondcenter.y=0.0;
	/*mijnrad=0;
	if(mijndims.x/2.0>mijnrad)mijnrad=mijndims.x/2.0;
	if(mijndims.y/2.0>mijnrad)mijnrad=mijndims.y/2.0;
	if(mijndims.z/2.0>mijnrad)mijnrad=mijndims.z/2.0;
*/
	//printf("Ik ben een obstakel met mijn voetcentrum op (%f,%f,%f)\n",pos.x,pos.y,pos.z);
	vect dimoffset(vectmult(mijndims,-0.5));
	mijnrot=rot;
	dimoffset.y=0;
	
	punt[4].zetmij(dimoffset);//vectplusvect(pos,dimoffset));
	punt[5].zetmij(vectplusvect(punt[4],vectmultvect(dimensies,vect(1,0,0))));
	punt[6].zetmij(vectplusvect(punt[4],vectmultvect(dimensies,vect(1,0,1))));
	punt[7].zetmij(vectplusvect(punt[4],vectmultvect(dimensies,vect(0,0,1))));
	
	for(int i=0;i<4;i++)
		punt[i].zetmij(vectplusvect(punt[i+4],vect(0,dimensies.y,0)));
		
	vect rotas(0,1.0,0);
	for(int i=0;i<8;i++)
	{
		//x' = x cos f - y sin f
		//y' = y cos f + x sin f
		float ouwex=punt[i].x;
		float ouwey=punt[i].z;
		punt[i].x=ouwex*cosf(rot) - ouwey*sinf(rot);
		punt[i].z=ouwey*cosf(rot) + ouwex*sinf(rot);
	}
	
	for(int i=0;i<8;i++)
	{
		
		punt[i].zetmij(vectplusvect(punt[i],pos));
		vertices[i][0]=punt[i].x;
		vertices[i][1]=punt[i].y;
		vertices[i][2]=punt[i].z;
	}
	
	overhoeveelrandenligikheen=0;
	klonen=NULL;
	
}

obstakel::~obstakel()
{
	if(overhoeveelrandenligikheen>0)
		delete[] klonen;
	klonen=NULL;
	overhoeveelrandenligikheen=0;
}	

void obstakel::verwerkjeoverlaps(float wereldrad)
{
	if(benikrond)
	{
		if((grondcenter.x+mijnrad>wereldrad || grondcenter.x-mijnrad<-wereldrad) && (grondcenter.z+mijnrad>wereldrad || grondcenter.z-mijnrad<-wereldrad)){
			overhoeveelrandenligikheen=3;
			klonen=new obstakel[3];
			int xsign=1,zsign=1;
			if(grondcenter.x-mijnrad<-wereldrad) xsign=-1;
			if(grondcenter.z-mijnrad<-wereldrad) zsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z),mijnrad,mijnhoogte);
			klonen[1].berekenmij(vect(grondcenter.x,0,grondcenter.z+(wereldrad*2*-zsign)),mijnrad,mijnhoogte);
			klonen[2].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z+(wereldrad*2*-zsign)),mijnrad,mijnhoogte);
			
		}else if((grondcenter.x+mijnrad>wereldrad || grondcenter.x-mijnrad<-wereldrad) && !(grondcenter.z+mijnrad>wereldrad || grondcenter.z-mijnrad<-wereldrad)){
			overhoeveelrandenligikheen=1;
			klonen=new obstakel[1];
			int xsign=1;
			if(grondcenter.x-mijnrad<-wereldrad) xsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z),mijnrad,mijnhoogte);
			
		}else if(!(grondcenter.x+mijnrad>wereldrad || grondcenter.x-mijnrad<-wereldrad) && (grondcenter.z+mijnrad>wereldrad || grondcenter.z-mijnrad<-wereldrad)){
			overhoeveelrandenligikheen=1;
			klonen=new obstakel[1];
			int zsign=1;
			if(grondcenter.z-mijnrad<-wereldrad) zsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x,0,grondcenter.z+(wereldrad*2*-zsign)),mijnrad,mijnhoogte);
			
		}
		
	}else{
		float xmin=0,xmax=0,zmin=0,zmax=0;
		for(int i=4;i<8;i++)
		{
			if(punt[i].x<xmin)xmin=punt[i].x;
			if(punt[i].x>xmax)xmax=punt[i].x;
			if(punt[i].z<zmin)zmin=punt[i].z;
			if(punt[i].z>zmax)zmax=punt[i].z;
		}	

		if((xmax>wereldrad || xmin<-wereldrad) && (zmax>wereldrad || zmin<-wereldrad)){
			overhoeveelrandenligikheen=3;
			klonen=new obstakel[3];
			int xsign=1,zsign=1;
			if(xmin<-wereldrad) xsign=-1;
			if(zmin<-wereldrad) zsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z),mijnrot,mijndims);
			klonen[1].berekenmij(vect(grondcenter.x,0,grondcenter.z+(wereldrad*2*-zsign)),mijnrot,mijndims);
			klonen[2].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z+(wereldrad*2*-zsign)),mijnrot,mijndims);
			
		}else if((xmax>wereldrad || xmin<-wereldrad) && !(zmax>wereldrad || zmin<-wereldrad)){
			overhoeveelrandenligikheen=1;
			klonen=new obstakel[1];
			int xsign=1;
			if(xmin<-wereldrad) xsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x+(wereldrad*2*-xsign),0,grondcenter.z),mijnrot,mijndims);
			
		}else if(!(xmax>wereldrad || xmin<-wereldrad) && (zmax>wereldrad || zmin<-wereldrad)){
			overhoeveelrandenligikheen=1;
			klonen=new obstakel[1];
			int zsign=1;
			if(zmin<-wereldrad) zsign=-1;
			klonen[0].berekenmij(vect(grondcenter.x,0,grondcenter.z+(wereldrad*2*-zsign)),mijnrot,mijndims);
			
		}
	
	}
	
	for(int i=0;i<overhoeveelrandenligikheen;i++) 
		klonen[i].kleur.zetmij(kleur);

}

void obstakel::draw()
{
	if(!benikrond)
	{
		glBegin(GL_TRIANGLES);
		//colorvect(kleur);
		glColor4f(kleur.x,kleur.y,kleur.z,WERELDALPHA);
		for(int i=0;i<12;i++)
		{
		
			normalvect(doenormaal(punt[triangles[i][0]],punt[triangles[i][1]],punt[triangles[i][2]]));
			/*vertexvect(punt[triangles[i][0]]);
			vertexvect(punt[triangles[i][1]]);
			vertexvect(punt[triangles[i][2]]);*/
		
			float xmult=1;
			float ymult=1;
			float divider=1.0;
		
			switch(i)
			{
			case 0:
			case 1:
			case 10:
			case 11:
				xmult=mijndims.x/divider;
				ymult=mijndims.z/divider;
				break;
			case 2:
			case 3:
			case 6:
			case 7:
				xmult=mijndims.x/divider;
				ymult=mijndims.y/divider;
				break;
			case 4:
			case 5:
				xmult=mijndims.z/divider;
				ymult=mijndims.y/divider;
				break;
			case 8:
			case 9:
				xmult=mijndims.y/divider;
				ymult=mijndims.z/divider;
				break;
			}

		
			if(i%2==0)glTexCoord2f(0,0); else glTexCoord2f(xmult,ymult);
			glVertex3fv(vertices[triangles[i][0]]);
			if(i%2==0)glTexCoord2f(xmult,0); else glTexCoord2f(0,ymult);
			glVertex3fv(vertices[triangles[i][1]]);
			if(i%2==0)glTexCoord2f(0,ymult); else glTexCoord2f(xmult,0);
			glVertex3fv(vertices[triangles[i][2]]);
		
		}
		glEnd();
	}else{
		
		vect middelboven(grondcenter.x,mijnhoogte,grondcenter.z);
		vect punkten[4];
		glBegin(GL_TRIANGLES);
		colorvect(kleur);
		for(float i=0;i<OBSTAKELSEGMENTEN;i++)
		{
			for(int ii=0;ii<4;ii++)
				punkten[ii].zetmij(middelboven);
				
			punkten[0].y=0;
			punkten[1].y=0;	
			
			punkten[0].x+=sinf((i/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			punkten[0].z+=cosf((i/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			
			punkten[3].x+=sinf((i/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			punkten[3].z+=cosf((i/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			
			punkten[1].x+=sinf(((i+1)/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			punkten[1].z+=cosf(((i+1)/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			
			punkten[2].x+=sinf(((i+1)/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			punkten[2].z+=cosf(((i+1)/OBSTAKELSEGMENTEN)*M_PI*2.0)*mijnrad;
			
//			for(int ii=0;ii<4;ii++)
//				printf("punkten[%d]=(%f,%f,%f)\n",ii,punkten[ii].x,punkten[ii].y,punkten[ii].z);
				
			normalvect(doenormaal(punkten[0],punkten[1],punkten[2]));
			glTexCoord2f((-1.0+(((i)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,0.5);		vertexvect(punkten[0]);
			glTexCoord2f((-1.0+(((i+1)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,0.5);		vertexvect(punkten[1]);
			glTexCoord2f((-1.0+(((i+1)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,mijnhoogte);	vertexvect(punkten[2]);
			
			normalvect(doenormaal(punkten[3],punkten[0],punkten[2]));
			glTexCoord2f((-1.0+(((i)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,mijnhoogte);		vertexvect(punkten[3]);
			glTexCoord2f((-1.0+(((i)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,0.5); 		vertexvect(punkten[0]);
			glTexCoord2f((-1.0+(((i+1)/OBSTAKELSEGMENTEN)*2.0))*M_PI*mijnrad*2.0,mijnhoogte);	vertexvect(punkten[2]);
		}
		glEnd();
	}
}

float convert(float in,float WofH,float ooitrad)
{
	float gewenstrad=WofH/2.0;
	return gewenstrad+((in/ooitrad)*gewenstrad);
}
void tekenlijncirkel(vect middel,float mijnrad,float W,float H,float rad,vect kleur)
{
	glBegin(GL_LINE_LOOP);
		colorvect(kleur);
		for(float i=0;i<OBSTAKELLIJNSEGMENTEN;i++)
		{
			vect punkt(middel);
			punkt.x+=sinf((i/OBSTAKELLIJNSEGMENTEN)*M_PI*2.0)*mijnrad;
			punkt.y+=cosf((i/OBSTAKELLIJNSEGMENTEN)*M_PI*2.0)*mijnrad;
			
			glVertex3f(convert(punkt.x,W,rad),convert(punkt.y,H,rad),0.0);
		}
		glEnd();
}

void tekenlijn(float x1,float z1,float x2,float z2,float W,float H,float rad)
{

	const float flip=1.0; //zodat links op danstextuur ook links in zichtwereld is doe ik yval*-1.0 //uhm...
	glVertex3f(convert(x1,W,rad),convert(z1*flip,H,rad),0.0); 
	glVertex3f(convert(x2,W,rad),convert(z2*flip,H,rad),0.0);
	
/*	if(x1<-rad || x2<-rad){
		glVertex3f(convert(x1+(rad*2),W,rad),convert(z1*flip,H,rad),0.0); 
		glVertex3f(convert(x2+(rad*2),W,rad),convert(z2*flip,H,rad),0.0);
		if(z1<-rad || z2<-rad){
			glVertex3f(convert(x1+(rad*2),W,rad),convert((z1+(rad*2))*flip,H,rad),0.0);
			glVertex3f(convert(x2+(rad*2),W,rad),convert((z2+(rad*2))*flip,H,rad),0.0);
		}else if(z1>rad || z2>rad){
			glVertex3f(convert(x1+(rad*2),W,rad),convert((z1-(rad*2))*flip,H,rad),0.0);
			glVertex3f(convert(x2+(rad*2),W,rad),convert((z2-(rad*2))*flip,H,rad),0.0);
		}
	}else if(x1>rad || x2>rad){
		glVertex3f(convert(x1-(rad*2),W,rad),convert(z1*flip,H,rad),0.0); 
		glVertex3f(convert(x2-(rad*2),W,rad),convert(z2*flip,H,rad),0.0);
		if(z1<-rad || z2<-rad){
			glVertex3f(convert(x1-(rad*2),W,rad),convert((z1+(rad*2))*flip,H,rad),0.0);
			glVertex3f(convert(x2-(rad*2),W,rad),convert((z2+(rad*2))*flip,H,rad),0.0);
		}else if(z1>rad || z2>rad){
			glVertex3f(convert(x1-(rad*2),W,rad),convert((z1-(rad*2))*flip,H,rad),0.0);
			glVertex3f(convert(x2-(rad*2),W,rad),convert((z2-(rad*2))*flip,H,rad),0.0);
		}
	}*/
}
void obstakel::drawlijntjes(float W,float H,float rad)
{ //4567 is y0

	for(int i=0;i<overhoeveelrandenligikheen;i++) 
		klonen[i].drawlijntjes(W,H,rad);
	
	
	if(!benikrond)
	{
		glBegin(GL_LINES);
		colorvect(kleur);
		tekenlijn(punt[4].x,punt[4].z,punt[5].x,punt[5].z,W,H,rad);
		tekenlijn(punt[5].x,punt[5].z,punt[6].x,punt[6].z,W,H,rad);
		tekenlijn(punt[6].x,punt[6].z,punt[7].x,punt[7].z,W,H,rad);
		tekenlijn(punt[7].x,punt[7].z,punt[4].x,punt[4].z,W,H,rad);
		glEnd();
	}else{
	
		//Hier rondheid tekenen
		vect middel(grondcenter.x,grondcenter.z,0.0);
		tekenlijncirkel(middel,mijnrad,W,H,rad,kleur);
		
		/*if(grondcenter.x+mijnrad>rad){
			tekenlijncirkel(vect(grondcenter.x-(rad*2),grondcenter.z,0),mijnrad,W,H,rad,kleur);
				if(grondcenter.z+mijnrad>rad) tekenlijncirkel(vect(grondcenter.x-(rad*2),grondcenter.z-(rad*2),0),mijnrad,W,H,rad,kleur);
				else if(grondcenter.z-mijnrad<-rad) tekenlijncirkel(vect(grondcenter.x-(rad*2),grondcenter.z+(rad*2),0),mijnrad,W,H,rad,kleur);
		}else if(grondcenter.x-mijnrad<-rad){
			tekenlijncirkel(vect(grondcenter.x+(rad*2),grondcenter.z,0),mijnrad,W,H,rad,kleur);
				if(grondcenter.z+mijnrad>rad) tekenlijncirkel(vect(grondcenter.x+(rad*2),grondcenter.z-(rad*2),0),mijnrad,W,H,rad,kleur);
				else if(grondcenter.z-mijnrad<-rad) tekenlijncirkel(vect(grondcenter.x+(rad*2),grondcenter.z+(rad*2),0),mijnrad,W,H,rad,kleur);
		}else{
			if(grondcenter.z+mijnrad>rad) tekenlijncirkel(vect(grondcenter.x,grondcenter.z-(rad*2),0),mijnrad,W,H,rad,kleur);
			if(grondcenter.z-mijnrad<-rad) tekenlijncirkel(vect(grondcenter.x,grondcenter.z+(rad*2),0),mijnrad,W,H,rad,kleur);
		}*/
	}
}

float sgn(float x)
{
	if(x<0) return -1.0;
	else return 1.0;
}



lijnintersect::lijnintersect()
{
	parallel=false;
	intersectie.zetmij(0,0,0);
	isereenintersect=false;
	afstand=10000000000;
	erisafstand=false;
	bijposafstand=1000000;
}

void lijnintersect::zetintersect(vect inter)
{
	isereenintersect=true;
	parallel=false;
	intersectie.zetmij(inter);
	afstand=0;
	erisafstand=false;
}

void lijnintersect::zetafstand(float nwafstand)
{
	isereenintersect=false;
	parallel=false;
	intersectie.zetmij(vect(0,0,0));
	afstand=nwafstand;
	erisafstand=true;
}

void lijnintersect::lijnenzijnparallelenoverlappen(vect inter)
{
	parallel=true;
	isereenintersect=true;
	afstand=0;
	intersectie.zetmij(inter);
	erisafstand=false;
}


float afstandtotlijn(vect pos,vect lijnorigin,vect naareinde) //http://en.wikipedia.org/wiki/Distance_from_a_point_to_a_line#Vector_formulation
{
	vect tenopzich(vectminvect(pos,lijnorigin));
	float dotneut=vectdotproduct(naareinde,naareinde);
	float doutpunt=vectdotproduct(tenopzich,naareinde);
	
	if(doutpunt<0) return vectafstand(pos,lijnorigin);
	else if(doutpunt>dotneut) return vectafstand(pos,vectplusvect(lijnorigin,naareinde));
	else return vectafstand(tenopzich,vectmult(naareinde,doutpunt/dotneut));
}


bool valikoplijn(vect pos,vect lijnorigin,vect naareinde) 
{
	float afstand=afstandtotlijn(pos,lijnorigin,naareinde);
	if(afstand<=0.5) return true;
	else return false;
}

vect puntoplijn(vect pos,vect lijnorigin,vect naareinde) 
{

	
	vect tenopzich(vectminvect(pos,lijnorigin));
	float dotneut=vectdotproduct(naareinde,naareinde);
	float doutpunt=vectdotproduct(tenopzich,naareinde);
	
	
	
	if(doutpunt<0.0) return lijnorigin;
	else if(doutpunt>dotneut) return vectplusvect(lijnorigin,naareinde);
	else return vectplusvect(lijnorigin,vectmult(naareinde,doutpunt/dotneut));
}



lijnintersect linelineintersectlinear(vect phi0,vect phi1,vect psi0,vect psi1) //phi0 is bijpos  //http://en.wikipedia.org/wiki/Line-line_intersection
{	

	lijnintersect uit;
	uit.bijposafstand=afstandtotlijn(phi0,psi0,(vectminvect(psi1,psi0)));
	uit.isereenintersect=false;
	if(vectafstand(phi0,phi1)==0.0)
	{
		uit.zetafstand(afstandtotlijn(phi1,psi0,(vectminvect(psi1,psi0)))); 
		
		return uit;
	}
	
	//ax+c = bx+d
	vect phi(vectminvect(phi1,phi0));
	vect psi(vectminvect(psi1,psi0));
	
	float phialpha=phi.z/phi.x;
	float psialpha=psi.z/psi.x;
	float phiconstant=phi0.z-(phi0.x*phialpha);
	float psiconstant=psi0.z-(psi0.x*psialpha);
	
	if(phi.x==0.0 || psi.x==0.0){ //verticaal
		//printf("Verticaal! %f\n",phi0.x-psi0.x);
		if(phi0.x!=psi0.x) // verticaal zonder x delen betekent niet overlappen
			uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		else{ //liggen op zelfde lijn
			if(afstandtotlijn(phi0,psi0,psi)==0.0) //bij ligt zelf in lijn
				uit.zetintersect(phi0);
			else if(afstandtotlijn(phi1,psi0,psi)==0.0) //bij niet maar pos wel in lijn
				uit.zetintersect(puntoplijn(phi0,psi0,psi));
			else //bij niet op lijn, pos ook niet, dus afstand
				uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		}	
	}else if(phialpha==psialpha){ //parallel
		//printf("Parallel!\n");
		float bijaf=afstandtotlijn(phi0,psi0,psi);
		if(bijaf==0.0) //dan kan die niks zien
			uit.zetintersect(phi0);
		else{
			float posaf=afstandtotlijn(phi0,psi0,psi);
			if(posaf==0.0) //bijpos niet en pos wel op lijn intersectie dus met
				uit.zetintersect(puntoplijn(phi0,psi0,psi));
			else //geen intersectie want overlappen niet eens in de oneindigheid
				uit.zetafstand(posaf);
		}
	}else{ //de kruising berekenen  //if(phi.z==0.0 && psi.z==0.0) wordt al gedaan door a==b
		vect kruis;
		const float afval=0.01;
	//	printf("Gekruisigd!\n");
	//	printf("phiy=%f*x+%f psiy=%f*x+%f\n",phialpha,phiconstant,psialpha,psiconstant);
		if(phi.z==0.0){
			kruis.z=phi0.z;
			/*
			phi0.z=(psialpha*x)+psiconstant
			phi0.z-psiconstant=psialpha*x
			(phi0.z-psiconstant)/psialpha=x
			*/
			kruis.x=(kruis.z-psiconstant)/psialpha;
			if(valikoplijn(kruis,psi0,psi)) uit.zetintersect(kruis);
			else uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		}else if(psi.z==0.0){
			kruis.z=psi0.z;
			kruis.x=(kruis.z-phiconstant)/phialpha;
			if(valikoplijn(kruis,psi0,psi)) uit.zetintersect(kruis);
			else uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		}else{ //niet horizontaal, niet verticaal, niet parallel, dus gekruist ergens.
			/*
				phiz=phialpha*x+phiconstant==psiz=psialpha*x+psiconstant
				phialpha*x+phiconstant=psialpha*x+psiconstant
				phialpha*x+phiconstant-psiconstant=psialpha*x
				phiconstant-psiconstant=psialpha*x-phialpha*x
				phiconstant-psiconstant=(psialpha-phialpha)*x
				(phiconstant-psiconstant)/(psialpha-phialpha)==x
			*/
			kruis.x=(phiconstant-psiconstant)/(psialpha-phialpha);
			kruis.z=(kruis.x*phialpha)+phiconstant;
			float af=afstandtotlijn(kruis,psi0,psi);
			if(valikoplijn(kruis,psi0,psi)) uit.zetintersect(kruis);
			else uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		}
	//	if(afstandtotlijn(kruis,psi0,psi)<0.5) printf("kruis = %f,%f  en  af=%f\npsi=%f,%f > %f,%f & phi=%f,%f > %f,%f\n",kruis.x,kruis.z,afstandtotlijn(kruis,psi0,psi),psi0.x,psi0.z,psi1.x,psi1.z,phi0.x,phi0.z,phi1.x,phi1.z);
	
	}
	
	
	
	if(uit.isereenintersect) //er is dus een intersectie, laten we die omzetten naar een negatieve afstand;
	{
		//printf("intersect=%f,%f",uit.intersectie.x,uit.intersectie.z);
		
		vect intersectiepunt=uit.intersectie;
		if(!valikoplijn(phi0,intersectiepunt,vectminvect(phi1,intersectiepunt)))
		{
			uit.zetafstand(-1.0*(vectafstand(phi0,phi1)-vectafstand(intersectiepunt,phi0)));
			if(uit.afstand<0.0) uit.isereenintersect=true;
			uit.bijposafstand=vectafstand(intersectiepunt,phi0);
		}else{
			uit.zetafstand(afstandtotlijn(phi1,psi0,psi));
		}
		//printf(" ->  afstand=%f\n",uit.afstand);
	
	}
	
	return uit;
	
}

lijnintersect linelineintersect(vect phi0,vect phi1,vect psi0,vect psi1)
{
	//if(true)
	//	return linelineintersecthomogeenwerktniet(phi0,phi1,psi0,psi1);
//	else
		return linelineintersectlinear(phi0,phi1,psi0,psi1);
}


lijnintersect obstakel::hoevermis(vect pos,vect bijpos)
{
	pos.y=0;
	bijpos.y=0.0;
	lijnintersect uitput;
	uitput.bijposafstand=100000;
	uitput.zetafstand(1000000);
	//float uitput=100000; //Wereld radius moet erg groot zijn wil dit niet een redelijk maximum zijn.
	if(benikrond) //http://mathworld.wolfram.com/Circle-LineIntersection.html
	{
		
		
		vect bijposcirkel(vectminvect(bijpos,grondcenter));
		vect poscirkel(vectminvect(pos,grondcenter));
		vect d(vectminvect(poscirkel,bijposcirkel));
		
		float dr=vectlengte(d);//sqrt((d.x*d.x)+(d.z*d.z));
		float D=(bijposcirkel.x*poscirkel.z)-(bijposcirkel.z*poscirkel.x);
		float delta=((mijnrad*mijnrad)*(dr*dr))-(D*D);
		float r=mijnrad;
		
		if(delta<=0.0) //geen intersectie // of slechts eentje en dat betekent dat ie geschampt wordt dus ligt pos buiten de cirkel, of er precies op.
		{
			if(false){ //de maximale misgeschotenheid.
				uitput.zetafstand(vectlengte(vectminvect(pos,bijpos)));
			}else{ //anders krijg je grote waardes voor misschieten, zo net langs heen..
				float afstandvancenter=vectlengte(vectminvect(pos,grondcenter));
				uitput.zetafstand(afstandvancenter-mijnrad);
			}
		
		//}//else if(delta==0.0){
		//	uitput.zetafstand(0); //er is maar een intersectie, dat betekent dat ie op het oppervlakte ligt, dus 0.0 afstand;
			
		}else{
			//x=(D*dy+-sgn(dy)*dx*sqrt(r^2*dr^2-D^2))/dr^2
			//y=(-D*dx+-|dy|sqrt(r^2*dr^2-D^2))/dr^2

			float X1=((D*d.z)-(sgn(d.z)*d.x*sqrt((r*r*dr*dr)-(D*D))))/(dr*dr);
			float X2=((D*d.z)+(sgn(d.z)*d.x*sqrt((r*r*dr*dr)-(D*D))))/(dr*dr);
			float Y1=((-D*d.x)-(fabs(d.z)*sqrt((r*r*dr*dr)-(D*D))))/(dr*dr);
			float Y2=((-D*d.x)+(fabs(d.z)*sqrt((r*r*dr*dr)-(D*D))))/(dr*dr);
			vect XY1(X1,0,Y1);
			vect XY2(X2,0,Y2);
			vect RELAXY1=vectminvect(XY1,bijposcirkel);
			vect RELAXY2=vectminvect(XY2,bijposcirkel);
			float d1=vectlengte(RELAXY1);
			float d2=vectlengte(RELAXY2);
			
			if(d1<d2)
				if(vectdotproduct(RELAXY1,d)>0 ) uitput.zetafstand(d1-dr);
				else uitput.zetafstand(d1+dr);
			else
				if(vectdotproduct(RELAXY2,d)>0 ) uitput.zetafstand(d2-dr);
				else uitput.zetafstand(d2+dr);
		}
		
		uitput.bijposafstand=vectlengte(vectminvect(bijpos,grondcenter))-mijnrad;
		
	}else{
		vect p[4];
		p[0].zetmij(punt[4]); p[0].y=0;
		p[1].zetmij(punt[5]); p[1].y=0;
		p[2].zetmij(punt[6]); p[2].y=0;
		p[3].zetmij(punt[7]); p[3].y=0;
		
		lijnintersect l[4];
		l[0]=linelineintersect(bijpos,pos,p[0],p[1]); //phi0 is bijpos
		l[1]=linelineintersect(bijpos,pos,p[1],p[2]);
		l[2]=linelineintersect(bijpos,pos,p[2],p[3]);
		l[3]=linelineintersect(bijpos,pos,p[3],p[0]);
		

		float minafstand=10000;
		float minbijposafstand=10000;
		bool intersectiegevonden=false;
		vect intersectdichtstebijbij(pos);
		int indexminste=-1;
		for(int i=0;i<4;i++)
		{
			if(l[i].bijposafstand<minbijposafstand && l[i].isereenintersect)
			{
				uitput=l[i];
				minbijposafstand=l[i].bijposafstand;
			}
			
			if(l[i].erisafstand && l[i].afstand<minafstand)
			{
				minafstand=l[i].afstand;
				indexminste=i;
			}	
		}
		
		if(!uitput.isereenintersect && minafstand!=0) uitput=l[indexminste];
		
		//uitput=l[0];
		
	}
	
	
	
	for(int i=0;i<overhoeveelrandenligikheen;i++) //if(overhoeveelrandenligikheen>0) is niet nodig want als gelijk 0 dan is de loop niet nodig
	{
		lijnintersect tmp=klonen[i].hoevermis(pos,bijpos);
		if(tmp.bijposafstand<uitput.bijposafstand && tmp.isereenintersect) uitput=tmp;
		if(tmp.afstand<uitput.afstand && !uitput.isereenintersect) uitput=tmp;
	}
	
	
	return uitput;
}


bool obstakel::vrijepositie(vect pos) //http://stackoverflow.com/questions/2752725/finding-whether-a-point-lies-inside-a-rectangle-or-not
{
	
	if(!benikrond)
	{
		pos.y=0;
		vect p4(punt[4]); p4.y=0;
		vect p5(punt[5]); p5.y=0;
		vect p7(punt[7]); p7.y=0;
		vect da(vectminvect(p5,p4));
		vect dc(vectminvect(p7,p4));
		vect dp(vectminvect(pos,p4));


		float dadotdp=vectdotproduct(da,dp);
		float dadotda=vectdotproduct(da,da);
	
		float dcdotdp=vectdotproduct(dc,dp);
		float dcdotdc=vectdotproduct(dc,dc);
	

		if(((0<=dadotdp && dadotdp<=dadotda) && (0<=dcdotdp && dcdotdp<=dcdotdc)))
			return false;
	
	
		return true;
	}else{
		
		float afstandvancenter=vectlengte(vectminvect(pos,grondcenter));
		if(afstandvancenter-mijnrad<=0.0) return false;
		else return true;
	}
}
void wereld::logtofile(std::string varname,bool varval)
{

	char l[50];
	if(varval) sprintf(l,"%s=true\n",varname.c_str());
	else sprintf(l,"%s=false\n",varname.c_str());
	logtofile(string(l));
}

void wereld::logtofile(std::string varname,enum grondtexturen varval)
{

	char l[50];
	switch(varval)
	{
	case schaakbord:
		sprintf(l,"%s=schaakbord\n",varname.c_str());
		break;
	case ruis:
		sprintf(l,"%s=ruis\n",varname.c_str());
		break;
	case simplesinus:
		sprintf(l,"%s=simplesinus\n",varname.c_str());
		break;
	case horivertidia:
		sprintf(l,"%s=horivertidia\n",varname.c_str());
		break;
	case standaard:
		sprintf(l,"%s=standaard\n",varname.c_str());
		break;
	}
	
	logtofile(string(l));
}


void wereld::logtofile(string varname,double varval)
{

	char l[50];
	sprintf(l,"%s=%f\n",varname.c_str(),(float)varval);
	logtofile(string(l));
}

void wereld::logtofile(string varname,float varval)
{

	char l[50];
	sprintf(l,"%s=%f\n",varname.c_str(),varval);
	logtofile(string(l));
}

void wereld::logtofile(string varname,int varval)
{
	char l[50];
	sprintf(l,"%s=%d\n",varname.c_str(),varval);
	logtofile(string(l));
}
void wereld::logtofile(string regel)
{
	logfile << regel.c_str();
	logfile.flush();
}

void wereld::voegmijnstaptoe(float lengtestap)
{
	gezettestappen++;
	totaleafgelegdeafstand+=lengtestap;
}

const bool zwartedans=false;
wereld::wereld(float vloerradius,int hoeveelobstakels,class framebufferobject *textuur)
{
	totaleafgelegdeafstand=0.0;
	gezettestappen=0;
	gegenereerdetextuur=textuur;
	logos=creeernaam(7);
	bool directorygemaakt=false;
	string checkme="";
	while(!directorygemaakt)
	{
		struct stat sb;
		checkme="./screenshots/"+logos;
		if((stat(checkme.c_str(), &sb) == 0 && S_ISDIR(sb.st_mode)))
		{
		    logos=creeernaam(7);
		}else{    
		    if(mkdir(checkme.c_str(),S_IRWXU)==-1)
		    {
		    	printf("%s directory does not exist and cannot be created... exiting\n",checkme.c_str());
		    	exit(-1);
		    }else directorygemaakt=true;
		}
	}
	string logfilename=checkme+"/"+logos+".log";
	logfile.open(logfilename.c_str());
	logfile << "This file describes the happenings of this world.\n";
	logtofile(string("BIJSPEED"),BIJSPEED);
	logtofile(string("BIJRADIUS"),BIJRADIUS);
	screenshotcounter=0;
	raakgeschoten=0;
	misgeschoten=0;
	mijnradius=vloerradius;
	aantalobstakels=hoeveelobstakels;
	
	mijnobstakels=new obstakel[aantalobstakels];
	const bool rondeobstakels=false;
	for(int i=0;i<aantalobstakels;i++)
	{
		if(i<(aantalobstakels/2)) 	mijnobstakels[i].berekenmij(vect(randfloat(-mijnradius,mijnradius),0,randfloat(-mijnradius,mijnradius)),randfloat(OBSTAKELMINRADIUS,OBSTAKELMAXRADIUS),4.5);
		else 				mijnobstakels[i].berekenmij(vect(randfloat(-mijnradius,mijnradius),0,randfloat(-mijnradius,mijnradius)),randfloat(-M_PI,M_PI),vect(randfloat(OBSTAKELMINRADIUS*2.0,OBSTAKELMAXRADIUS*2.0),4.5,randfloat(OBSTAKELMINRADIUS*2.0,OBSTAKELMAXRADIUS*2.0)));
		
		mijnobstakels[i].verwerkjeoverlaps(mijnradius);
	}	
	muren[0].berekenmij(vect(-mijnradius*2,0,0),0,vect(mijnradius*2,mijnradius/2,mijnradius*2));
	muren[1].berekenmij(vect( mijnradius*2,0,0),0,vect(mijnradius*2,mijnradius/2,mijnradius*2));
	muren[2].berekenmij(vect(0,0,-mijnradius*2),0,vect(mijnradius*2,mijnradius/2,mijnradius*2));
	muren[3].berekenmij(vect(0,0, mijnradius*2),0,vect(mijnradius*2,mijnradius/2,mijnradius*2));
	
	
	afbeelding=glGenLists(1);
	gegenereerdetextuur->bindtexture();
	glNewList(afbeelding, GL_COMPILE);
		
		float mult=GRONDTEXMULT;
		if(mult==-1.0) mult=mijnradius*2.0;
		glBegin(GL_TRIANGLES);
		glColor4f(1,1,1,WERELDALPHA);
			glTexCoord2f(0,0); glVertex3f(-mijnradius,0,-mijnradius);
			glTexCoord2f(0,mult); glVertex3f(-mijnradius,0, mijnradius);
			glTexCoord2f(mult,mult); glVertex3f( mijnradius,0, mijnradius);
	
			glTexCoord2f(0,0); glVertex3f(-mijnradius,0,-mijnradius);
			glTexCoord2f(mult,mult); glVertex3f( mijnradius,0, mijnradius);
			glTexCoord2f(mult,0); glVertex3f( mijnradius,0,-mijnradius);
		glEnd();
	
		for(int i=0;i<aantalobstakels;i++)
			mijnobstakels[i].draw();
		//for(int i=0;i<4;i++)muren[i].draw();
	glEndList();
	
	danstextuur=new framebufferobject(mijnradius*2*WERELDTEXRESMULT, mijnradius*2*WERELDTEXRESMULT, true, false, false, false, true,true);
	pngtextuur=new framebufferobject(mijnradius*2*WERELDTEXRESMULT, mijnradius*2*WERELDTEXRESMULT, true, false, false, false, true,false);
	
	pngtextuur->bindframebuffer();
	glLoadIdentity();
	
	if(!zwartedans)	glClearColor(1.0, 1.0, 1.0, 1.0);
	else		glClearColor(0.0,0.0,0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	danstextuur->bindframebuffer();
	glLoadIdentity();
	glClearColor(0.0,0.0,0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
}

int wereld::getdansdim()
{	return pngtextuur->getW(); }

void wereld::drawlijntjes()
{
	pngtextuur->bindframebuffer();
	glLoadIdentity();
	if(!zwartedans)	glClearColor(1.0, 1.0, 1.0, 1.0);
	else		glClearColor(0.0,0.0,0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glUseProgramObjectARB(0);
	
	
	if(TEKENTEXTUURINPLAATSZWART)
	{
		float texkracht=0.1;
		glColor4f(texkracht,texkracht,texkracht,texkracht);
		gegenereerdetextuur->bindtexture();
		glBegin(GL_TRIANGLES); 
			float mult=GRONDTEXMULT;
			if(mult==-1.0) mult=mijnradius*2.0;
			float H=pngtextuur->getH();
			float W=pngtextuur->getW();
			glTexCoord2f(0,0); 		glVertex3f(0,0,0.0);
			glTexCoord2f(0,mult);		glVertex3f(0,H,0.0);
			glTexCoord2f(mult,mult);	glVertex3f(W,H,0.0);
	
			glTexCoord2f(0,0); 		glVertex3f(0,0,0.0);
			glTexCoord2f(mult,mult);	glVertex3f(W,H,0.0);
			glTexCoord2f(mult,0);		glVertex3f(W,0,0.0);
			
		glEnd();
		
	}
	
	glDisable(GL_TEXTURE_2D);	
	
	for(int i=0;i<aantalobstakels;i++)
			mijnobstakels[i].drawlijntjes(getdansdim(),getdansdim(),mijnradius);
			
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendEquationSeparate(GL_FUNC_ADD, GL_FUNC_ADD);
	glBlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_ONE, GL_ZERO);
	danstextuur->bindtexture();
	drawtexturedquad(0,getdansdim(),getdansdim(),0);
	glDisable(GL_BLEND);
}

float wereld::getradius()
{
	return mijnradius;
}

void wereld::binddansfb()
{
	danstextuur->bindframebuffer();
	glLoadIdentity();
	glScalef(WERELDTEXRESMULT,WERELDTEXRESMULT,WERELDTEXRESMULT);
	glTranslatef(mijnradius, mijnradius,0.0);
}

void wereld::binddanstextuur()
{
	//danstextuur->bindtexture();
	pngtextuur->bindtexture();
}



void wereld::savedanstextuur()
{

	
	char teller[10];
	sprintf(teller,"%05d",screenshotcounter);
	string filename="./screenshots/"+logos+"/"+logos+"-"+teller+".png";
	pngtextuur->saveaspng(filename.c_str());
	screenshotcounter++;
	char uit[256];
	sprintf(uit,"Ik heb screenshot #%d gemaakt, daarbij is er %d maal raakgeschoten, ook is %d maal misgeschoten met een gemiddelde afwijking van het oppervlakte van %f\n",screenshotcounter,raakgeschoten,misgeschoten,opgeteldeminimaleafstand/(raakgeschoten+misgeschoten));
	printf("%s",uit);
	//logtofile(string(uit));
	
}

void wereld::draw()
{

	gegenereerdetextuur->bindtexture();
	glCallList(afbeelding);
	
	
	glPushMatrix();  //zodat wraparoundworld niet gek is? Alsin: zichtbaar :p
	glTranslatef(mijnradius*2,0,0);
	glCallList(afbeelding);
	glTranslatef(0,0,mijnradius*2);
	glCallList(afbeelding);
	glTranslatef(0,0,mijnradius*-4);
	glCallList(afbeelding);
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef(mijnradius*-2,0,0);
	glCallList(afbeelding);
	glTranslatef(0,0,mijnradius*2);
	glCallList(afbeelding);
	glTranslatef(0,0,mijnradius*-4);
	glCallList(afbeelding);
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef(0,0,mijnradius*2);
	glCallList(afbeelding);
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef(0,0,-mijnradius*2);
	glCallList(afbeelding);
	glPopMatrix();
		
}

bool wereld::vrijepositieomring(vect pos)
{
	//if(!(pos.x<mijnradius && pos.x>-mijnradius && pos.y<mijnradius && pos.y>-mijnradius && pos.z<mijnradius && pos.z>-mijnradius))
	//	return false;
		
	if(pos.x<mijnradius) pos.x+=mijnradius*2;
	if(pos.z<mijnradius) pos.z+=mijnradius*2;
	if(pos.x>mijnradius) pos.x-=mijnradius*2;
	if(pos.z>mijnradius) pos.z-=mijnradius*2;


	
	for(int i=0;i<aantalobstakels;i++)
		if(!(mijnobstakels[i].vrijepositie(pos)))
			return false;
	return true;
}


float wereld::hoevermis(vect pos,vect bijpos)
{
	//if(!(pos.x<mijnradius && pos.x>-mijnradius && pos.y<mijnradius && pos.y>-mijnradius && pos.z<mijnradius && pos.z>-mijnradius))
	//	return false;
		
	if(pos.x<mijnradius) pos.x+=mijnradius*2;
	if(pos.z<mijnradius) pos.z+=mijnradius*2;
	if(pos.x>mijnradius) pos.x-=mijnradius*2;
	if(pos.z>mijnradius) pos.z-=mijnradius*2;

	
	float minafstand=100000;
	lijnintersect minmis;
	minmis.zetafstand(10000000);
	minmis.bijposafstand=mijnradius*4; //moet dus wel groter zijn :p
	int rndcheck=rand()%aantalobstakels;
	for(int i=0;i<aantalobstakels;i++)
	{
		lijnintersect tmpmis=mijnobstakels[i].hoevermis(pos,bijpos);
		//printf("tmpmis for obstakel[%d]=%f\n",i,tmpmis);
		if(tmpmis.bijposafstand<minmis.bijposafstand && tmpmis.isereenintersect) minmis=tmpmis;
		if(tmpmis.afstand<minafstand) minafstand=tmpmis.afstand;
		//if(i==rndcheck) minmis=tmpmis;
	
	}
	if(minmis.isereenintersect) return minmis.afstand;
	else return minafstand;
}


void wereld::iserraakgeschoten(float x,float z,vect bijpos)
{
	vect pos(x,0,z);

/*	if(x>mijnradius || x<-mijnradius || z>mijnradius || z<-mijnradius)
	{
		misgeschoten++;
		return;
	}
	
	
		
	if(!vrijepositieomring(pos)) raakgeschoten++;
	else	misgeschoten++;
*/

	float minimaalmisser=hoevermis(pos,bijpos);
	opgeteldeminimaleafstand+=minimaalmisser;
	
	if(minimaalmisser<=0.0) raakgeschoten++;
	else misgeschoten++;
}

bool wereld::vrijepositie(vect pos)
{
	pos.y=0;
	if(!vrijepositieomring(pos)) return false;
	
	
	
	bool omringingzijnvrij=true;
	vect omringing[16];
	const float rondmult=M_PI/4.0;
	for(int i=0;i<16;i++)
	{
		omringing[i].z=pos.z+(sinf((rondmult*((float)i)))*BIJRADIUS*0.5);
		omringing[i].x=pos.x+(cosf((rondmult*((float)i)))*BIJRADIUS*0.5);
		omringing[i].y=0;
		if(!this->vrijepositieomring(omringing[i])) omringingzijnvrij=false;
	}

	return omringingzijnvrij;
	
}

void wereld::printapocalyptica()
{
	char apocalyptischereiter[300];
	if(CALCULATEOBJECTS)
	{
		printf("De wereld gaat ten onder maar er is ook goed nieuws!\nEr is %d maal raakgeschoten\nHelaas is er ook %d misgeschoten..\nDe gokken zaten gemiddeld %f naast het oppervlakte\n",raakgeschoten,misgeschoten,opgeteldeminimaleafstand/(misgeschoten+raakgeschoten));
		printf("Door alle bijen samen zijn %d stappen gezet en %f totale afstand afgelegd.\nGemiddeld per stap afgelegde afstand is dan %f\n",gezettestappen,totaleafgelegdeafstand,totaleafgelegdeafstand/((double)gezettestappen));
	
		sprintf(apocalyptischereiter,"%d screenshots genomen\n%d binnen obstakel, %d buiten obstakel\nmet een gemiddelde afwijking %f\n",screenshotcounter, raakgeschoten,misgeschoten,opgeteldeminimaleafstand/(misgeschoten+raakgeschoten));
		logtofile(apocalyptischereiter);
		sprintf(apocalyptischereiter,"Door alle bijen samen zijn %d stappen gezet en %f totale afstand afgelegd.\nGemiddeld per stap afgelegde afstand is dan %f\n",gezettestappen,totaleafgelegdeafstand,totaleafgelegdeafstand/((double)gezettestappen));
		logtofile(apocalyptischereiter);
	}
	if(CALCULATEPATH)
	{
		//printf("JE HEBT GEEN FUNCTIE GESCHREVEN OM AFWIJKING VAN GEVONDEN LOCATIE TEN OPZICHT VAN ECHTE LOCATIE COHERENT TE BEREKENEN!!!\n");
		//logtofile("JE HEBT GEEN FUNCTIE GESCHREVEN OM AFWIJKING VAN GEVONDEN LOCATIE TEN OPZICHT VAN ECHTE LOCATIE COHERENT TE BEREKENEN!!!\n");
		//Zit in (nexus.cpp).killfunctie()
	}
}


wereld::~wereld()
{

	printapocalyptica();
	logfile.close();
	
	if(danstextuur!=NULL) delete danstextuur;
	if(pngtextuur!=NULL) delete pngtextuur;
	danstextuur=NULL;
	pngtextuur=NULL;
	
	if(mijnobstakels!=NULL && aantalobstakels>0) 
	{
		//for(int i=0;i<aantalobstakels;i++)
		//	delete mijnobstakels[i];
		delete[] mijnobstakels;
		mijnobstakels=NULL;
		aantalobstakels=0;
	}
	
	glDeleteLists(afbeelding,1);
}
