#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <fstream>
using namespace std;

struct uit
{
	uit();
	int aantalstappen;
	float error;
	float errorperstap;
	bool dezemeetellen;
};

uit::uit()
{
	aantalstappen=0;
	error=0.0;
	errorperstap=0.0;
	dezemeetellen=false;
}



struct wattedoen
{
	wattedoen();
	bool specifiek[6];
	int retireso;
	int tijdreso;
	int aantalkijkhoeken;
	int ooghoek;
	int oogmult;
	string textuur;
	uit welkewaardesindezeregel(string regel);
};

wattedoen::wattedoen()
{
	for(int i=0;i<6;i++)
		specifiek[i]=false;
	retireso=-1;
	tijdreso=-1;
	textuur="-1";
	aantalkijkhoeken=-1;
	ooghoek=-1;
	oogmult=-1;
}

uit wattedoen::welkewaardesindezeregel(string regel)
{
	int tmpreti,tmptijd,tmpaantal;
	char tmptex[100];
	int tmpooghoek,tmpoogmult;
	uit out;
				//wereldnaam retireso tijdreso aantalkijkhoeken ooghoek oogmult error aantalstappen error/aantalstappen textuur
				//zjinbyngch 256      512      32               15      1 	0.143732 100        0.00143732          ruis
	sscanf(regel.c_str(),"%*s %d %d %d %d %d %f %d %f %s",&tmpreti,&tmptijd,&(tmpaantal),&(tmpooghoek),&(tmpoogmult),&(out.error),&(out.aantalstappen),&(out.errorperstap),tmptex);
	string tmptexstring=tmptex;
	//printf("%d %d %f %d %d %d %s %d %d\n",tmphori,tmptijd,(out.error),(out.hits),(out.misses),tmpaantal,tmptex,tmpsine,tmpverwerk);
	
	if(
		(!specifiek[0] || retireso==tmpreti)		&&
		(!specifiek[1] || tmptijd==tijdreso)		&&
		(!specifiek[2] || tmpaantal==aantalkijkhoeken)	&&
		(!specifiek[3] || tmptexstring==textuur)	&&
		(!specifiek[4] || tmpooghoek==ooghoek)		&&
		(!specifiek[5] || tmpoogmult==oogmult)		)		
		out.dezemeetellen=true;
	return out;
}

string onttrekdataaanlogfile(string naamlogfile,wattedoen verwerker)
{
	std::ifstream logfile;
	
	logfile.open(naamlogfile.c_str(),std::ifstream::in);
	if(!logfile.is_open())
	{
		printf("Opening logfile failed!\n");
		exit(1);
	}
		

	float averageerror=0.0;
	float aantalstappen=0;
	float errorperstap=0.0;
	float count=0;
	string regel;
	getline(logfile,regel); // is stomme eerste regel met veldnamen
		
		
	while(!logfile.eof())
	{
		
		getline(logfile,regel);
		
		uit val=verwerker.welkewaardesindezeregel(regel);
		//printf("%s gelezen\nGevonden vals= %f %d %d\n",regel.c_str(),val.error,val.hits,val.misses);
		if(val.dezemeetellen)
		{
			averageerror+=val.error;
			aantalstappen+=(float)val.aantalstappen;
			errorperstap+=val.errorperstap;
			count+=1.0;
		}
	}
	
	
	averageerror/=count;
	aantalstappen/=count;
	errorperstap/=count;
	
	char uit[600];
	
	sprintf(uit,"%d,%d,%d,%s,%d,%d,:==,%f,%f,%f,%f\n",verwerker.retireso,verwerker.tijdreso,verwerker.aantalkijkhoeken,verwerker.textuur.c_str(),verwerker.ooghoek,verwerker.oogmult,errorperstap,count,averageerror,aantalstappen);
	string uitstr=uit;
	logfile.close();
	if(count>0) return uitstr;
	else return string("");

}

int main(int argc, char **argv)
{
	
	
	if(argc!=8 && argc!=2){
		printf("Only %d arguments given..\nFormat: datafile.csv retireso tijdreso aantalstappen textuur sinegradient verwerkdistance\nFill in desired field-value or ! for all.\n",argc);
		exit(1);
	}
	
	if(argc==8)
	{
		wattedoen verwerker;
		for(int i=0;i<6;i++)
		{
			//printf("i=%d en arg=%s\n",i,argv[2+i]);
			if(argv[2+i][0]!='!')
			{
				//printf("i=%d en arg=%s\n",i,argv[2+i]);
				switch(i)
				{
				case 0:
					sscanf(argv[2+i],"%d",&(verwerker.retireso));
					verwerker.specifiek[i]=true;
					break;
				case 1:
					sscanf(argv[2+i],"%d",&(verwerker.tijdreso));
					verwerker.specifiek[i]=true;
					break;
				case 2:
					sscanf(argv[2+i],"%d",&(verwerker.aantalkijkhoeken));
					verwerker.specifiek[i]=true;
					break;
				case 3:
					verwerker.textuur=argv[2+i];
					verwerker.specifiek[i]=true;
					break;
				case 4:
					sscanf(argv[2+i],"%d",&(verwerker.ooghoek));
					verwerker.specifiek[i]=true;
					break;
				case 5:
					sscanf(argv[2+i],"%d",&(verwerker.oogmult));
					verwerker.specifiek[i]=true;
					break;
				}
			}
		}
		printf("%s",onttrekdataaanlogfile(string(argv[1]),verwerker).c_str());
		exit(0);
		
	}
	
	const int retiresos=3;
	const int tijdresos=4;
	const int ooghoeks=3;
	const int textuurs=4;
	const int hori[retiresos]={128,256,512};
	const int tijd[tijdresos]={64,128,256,512};
	const int ooghoeken[ooghoeks]={15,30,60};
	string texs[textuurs]={"schaakbord","ruis","simplesinus","horivertidia"};
	
	wattedoen verwerkers[retiresos][tijdresos][textuurs][2][ooghoeks];

	printf("retireso,tijdreso,aantalkijkhoeken,textuur,ooghoek,oogmult,:==,afwijking_per_stap,count,averageerror,aantalstappen\n");
	
	for(int h=0;h<retiresos+0;h++)
	for(int ti=0;ti<tijdresos+0;ti++)
	for(int te=0;te<textuurs+0;te++)
	for(int si=0;si<2+0;si++)
	for(int ve=0;ve<ooghoeks+0;ve++)
	{
		if(h<retiresos){ 	verwerkers[h][ti][te][si][ve].retireso=hori[h];		verwerkers[h][ti][te][si][ve].specifiek[0]=true; }
		if(ti<tijdresos){ 	verwerkers[h][ti][te][si][ve].tijdreso=tijd[ti];	verwerkers[h][ti][te][si][ve].specifiek[1]=true; }
		if(te<textuurs){ 	verwerkers[h][ti][te][si][ve].textuur=string(texs[te]);	verwerkers[h][ti][te][si][ve].specifiek[3]=true; }
		if(si<2){ 		verwerkers[h][ti][te][si][ve].oogmult=1.0+(3.0*si);	verwerkers[h][ti][te][si][ve].specifiek[4]=true; }
		if(ve<ooghoeks){ 		verwerkers[h][ti][te][si][ve].ooghoek=ooghoeken[ve];	verwerkers[h][ti][te][si][ve].specifiek[5]=true; }
		
		printf("%s",onttrekdataaanlogfile(string(argv[1]),verwerkers[h][ti][te][si][ve]).c_str());
	}
	
	
	
	
	return 0;
}



