#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <fstream>
using namespace std;

struct uit
{
	uit();
	int hits,misses;
	float error;
	bool dezemeetellen;
};

uit::uit()
{
	hits=0;
	misses=0;
	error=0.0;
	dezemeetellen=false;
}

struct wattedoen
{
	wattedoen();
	bool specifiek[6];
	int horireso;
	int tijdreso;
	int aantalstappen;
	string textuur;
	int sinegradient;
	int verwerkdistance;
	uit welkewaardesindezeregel(string regel);
};

wattedoen::wattedoen()
{
	for(int i=0;i<6;i++)
		specifiek[i]=false;
	horireso=0;
	tijdreso=0;
	aantalstappen=0;
	textuur="-";
	sinegradient=-1;
	verwerkdistance=-1;
}

uit wattedoen::welkewaardesindezeregel(string regel)
{
	int tmphori,tmptijd,tmpaantal,tmpsine,tmpverwerk;
	char tmptex[100];
	uit out;
				//botchritkirtkeirtgrijawoert 1024 	16 	-8.76817	 82789   44029 		1350       ruis	 0 		0
	sscanf(regel.c_str(),"%*s %d %d %f %d %d %d %s %d %d",&tmphori,&tmptijd,&(out.error),&(out.hits),&(out.misses),&tmpaantal,tmptex,&tmpsine,&tmpverwerk);
	string tmptexstring=tmptex;
	//printf("%d %d %f %d %d %d %s %d %d\n",tmphori,tmptijd,(out.error),(out.hits),(out.misses),tmpaantal,tmptex,tmpsine,tmpverwerk);
	
	if((!specifiek[0] || horireso==tmphori)&&
	(!specifiek[1] || tmptijd==tijdreso)&&
	(!specifiek[2] || tmpaantal==aantalstappen)&&
	(!specifiek[3] || tmptexstring==textuur)&&
	(!specifiek[4] || tmpsine==sinegradient)&&
	(!specifiek[5] || tmpverwerk==verwerkdistance))		
		out.dezemeetellen=true;
	return out;
}

string onttrekdataaanlogfile(string naamlogfile,wattedoen verwerker)
{
	std::ifstream logfile;
	
	logfile.open(naamlogfile.c_str(),std::ifstream::in);
	if(!logfile.is_open())
	{
		printf("Opening logfile failed!\n");
		exit(1);
	}
		

	float averageerror=0.0;
	float hits=0,misses=0;
	float count=0;
	string regel;
	getline(logfile,regel); // is stomme eerste regel met veldnamen
		
		
	while(!logfile.eof())
	{
		
		getline(logfile,regel);
		
		uit val=verwerker.welkewaardesindezeregel(regel);
		//printf("%s gelezen\nGevonden vals= %f %d %d\n",regel.c_str(),val.error,val.hits,val.misses);
		if(val.dezemeetellen)
		{
			averageerror+=val.error;
			hits+=(float)val.hits;
			misses+=(float)val.misses;
			count+=1.0;
		}
	}
	
	
	averageerror/=count;
	hits/=count;
	misses/=count;
	
	char uit[600];
	//sprintf(uit,"Results from %d %d %d %s %d %d are: count=%f error=%f hits/misses=%f hits=%f misses=%f\n",verwerker.horireso,verwerker.tijdreso,verwerker.aantalstappen,verwerker.textuur.c_str(),verwerker.sinegradient,verwerker.verwerkdistance,count,averageerror,((float)hits)/((float)misses),hits,misses);
	sprintf(uit,"%d,%d,%d,%s,%d,%d,:==,%f,%f,%f,%f,%f\n",verwerker.horireso,verwerker.tijdreso,verwerker.aantalstappen,verwerker.textuur.c_str(),verwerker.sinegradient,verwerker.verwerkdistance,count,averageerror,((float)hits)/((float)misses),hits,misses);
	string uitstr=uit;
	logfile.close();
	if(count>0) return uitstr;
	else return string("");

}

int main(int argc, char **argv)
{
	
	
	if(argc!=8 && argc!=2){
		printf("Only %d arguments given..\nFormat: datafile.csv horireso tijdreso aantalstappen textuur sinegradient verwerkdistance\nFill in desired field-value or ! for all.\n",argc);
		exit(1);
	}
	
	if(argc==8)
	{
		wattedoen verwerker;
		for(int i=0;i<6;i++)
		{
			//printf("i=%d en arg=%s\n",i,argv[2+i]);
			if(argv[2+i][0]!='!')
			{
				//printf("i=%d en arg=%s\n",i,argv[2+i]);
				switch(i)
				{
				case 0:
					sscanf(argv[2+i],"%d",&(verwerker.horireso));
					verwerker.specifiek[i]=true;
					break;
				case 1:
					sscanf(argv[2+i],"%d",&(verwerker.tijdreso));
					verwerker.specifiek[i]=true;
					break;
				case 2:
					sscanf(argv[2+i],"%d",&(verwerker.aantalstappen));
					verwerker.specifiek[i]=true;
					break;
				case 3:
					verwerker.textuur=argv[2+i];
					verwerker.specifiek[i]=true;
					break;
				case 4:
					sscanf(argv[2+i],"%d",&(verwerker.sinegradient));
					verwerker.specifiek[i]=true;
					break;
				case 5:
					sscanf(argv[2+i],"%d",&(verwerker.verwerkdistance));
					verwerker.specifiek[i]=true;
					break;
				}
			}
		}
		printf("%s",onttrekdataaanlogfile(string(argv[1]),verwerker).c_str());
		exit(0);
		
	}
	
	const int horiresos=3;
	const int tijdresos=4;
	const int textuurs=4;
	const int hori[horiresos]={128,512,1024};
	const int tijd[tijdresos]={16,32,128,512};
	string texs[textuurs]={"schaakbord","ruis","simplesinus","horivertidia"};
	
	wattedoen verwerkers[horiresos+1][tijdresos+1][textuurs+1][3][3];
	
	printf("horireso,tijdreso,aantalstappen,textuur,sinegradient,verwerkdistance,:==,count,averageerror,hits/misses,hits,misses\n");
	
	for(int h=0;h<horiresos+1;h++)
	for(int ti=0;ti<tijdresos+1;ti++)
	for(int te=0;te<textuurs+1;te++)
	for(int si=0;si<2+1;si++)
	for(int ve=0;ve<2+1;ve++)
	{
		if(h<horiresos){ 	verwerkers[h][ti][te][si][ve].horireso=hori[h];		verwerkers[h][ti][te][si][ve].specifiek[0]=true; }
		if(ti<tijdresos){ 	verwerkers[h][ti][te][si][ve].tijdreso=tijd[ti];	verwerkers[h][ti][te][si][ve].specifiek[1]=true; }
		if(te<textuurs){ 	verwerkers[h][ti][te][si][ve].textuur=string(texs[te]);	verwerkers[h][ti][te][si][ve].specifiek[3]=true; }
		if(si<2){ 		verwerkers[h][ti][te][si][ve].sinegradient=si;		verwerkers[h][ti][te][si][ve].specifiek[4]=true; }
		if(ve<2){ 		verwerkers[h][ti][te][si][ve].verwerkdistance=ve;	verwerkers[h][ti][te][si][ve].specifiek[5]=true; }
		
		printf("%s",onttrekdataaanlogfile(string(argv[1]),verwerkers[h][ti][te][si][ve]).c_str());
	}
	
	
	
	
	return 0;
}



